
var strings;


function init()
{
    strings = document.getElementById("strings");

    var synclocal;
    var localpath;

    var syncremote;
    var syncprotocol;
    var synchost='';
    var syncuser='';
    var syncpassword='';
    var syncpath='';
    var autoupload=false;
    var autodownload=false;

    try{ synctype = pref.getCharPref( "extensions.addressbookssync.synctype" ); } catch(e){ synctype='none'; }

    try{ localpath = pref.getCharPref( "extensions.addressbookssync.localpath" ); } catch(e){ localpath=''; }

    try{ syncprotocol = pref.getCharPref( "extensions.addressbookssync.protocol" ); } catch(e){}
    try{ synchost = pref.getCharPref( "extensions.addressbookssync.host" ); } catch(e){}
    try{ syncuser = pref.getCharPref( "extensions.addressbookssync.user" ); } catch(e){}
    try{ syncpassword = get_password(synchost, syncuser); } catch(e){}
    try{ syncpath = pref.getCharPref( "extensions.addressbookssync.path" ); } catch(e){}

    try{ autoupload = pref.getBoolPref( "extensions.addressbookssync.autoupload" ); } catch(e){}
    try{ autodownload = pref.getBoolPref( "extensions.addressbookssync.autodownload" ); } catch(e){}

    if (synctype=='local')
      document.getElementById("synctype").selectedItem=document.getElementById("synclocal")
    else if (synctype=='remote')
      document.getElementById("synctype").selectedItem=document.getElementById("syncremote")

    document.getElementById("localpath").value = localpath;

    document.getElementById("protocol").value = syncprotocol;
    document.getElementById("host").value = synchost;
    document.getElementById("username").value = syncuser;
    document.getElementById("password").value = syncpassword;
    document.getElementById("path").value = syncpath;

    document.getElementById("autoupload").checked = autoupload;
    document.getElementById("autodownload").checked = autodownload;


    // list address books
    var mabList = document.getElementById("MabList");
    var syncList = document.getElementById("SyncList");

    // get all MAB File
    var cn = directory.childNodes;
    var aBook = cn.getNext();
    while( aBook != null )
    {
        var cur = aBook.QueryInterface(Components.interfaces.nsIAbDirectory);
        var mabFile=cur.directoryProperties.fileName;
        var dirType = cur.directoryProperties.dirType;
        var description=cur.directoryProperties.description;

        mabList.appendItem( description, mabFile, "" ); // 'Store'

        //'Sync'
        var sync;
        if (mabFile!='history.mab' && mabFile!='abook.mab' && dirType==2) {
            // ignore history and pab and ldap-addressbooks
          var ncb=document.createElement('checkbox');
          ncb.setAttribute('id', 'addressbookssync_'+description);
          ncb.setAttribute('label', description);
          syncList.appendChild( ncb );

          var prefName = cur.directoryProperties.prefName;
          try { sync = pref.getBoolPref( prefName+".extensions.addressbookssync" ); } catch(e) { sync=0; }
          if (sync) ncb.setAttribute('checked', true);
        }
        try { aBook = cn.getNext(); } catch(e) { break; } // catch
    } // while
    mabList.selectedIndex = 0;

} // init



function finish()
{
    var localpath=document.getElementById("localpath").value;
    pref.setCharPref( "extensions.addressbookssync.localpath", localpath );
    if ( document.getElementById("synclocal").selected && localpath)
      pref.setCharPref( "extensions.addressbookssync.synctype", 'local' );
    else if ( document.getElementById("syncremote").selected )
      pref.setCharPref( "extensions.addressbookssync.synctype", 'remote' );
    else {
      pref.setCharPref( "extensions.addressbookssync.synctype", 'none' );
      document.getElementById("synctype").selectedItem=null;
    }

    pref.setBoolPref( "extensions.addressbookssync.syncremote", document.getElementById("syncremote").selected );
    pref.setCharPref( "extensions.addressbookssync.protocol", document.getElementById("protocol").value );
    var host=document.getElementById("host").value;  pref.setCharPref( "extensions.addressbookssync.host", host );
    var user=document.getElementById("username").value; pref.setCharPref( "extensions.addressbookssync.user", user );
    set_password(host,user,document.getElementById("password").value );
    pref.setCharPref( "extensions.addressbookssync.path", document.getElementById("path").value );
    pref.setBoolPref( "extensions.addressbookssync.autoupload", document.getElementById("autoupload").checked );
    pref.setBoolPref( "extensions.addressbookssync.autodownload", document.getElementById("autodownload").checked );

    var cn = directory.childNodes;
    var aBook = cn.getNext();
    while( aBook != null )
    {
      var cur = aBook.QueryInterface(Components.interfaces.nsIAbDirectory);
      var mabFile=cur.directoryProperties.fileName;
      var dirType = cur.directoryProperties.dirType;
      var description=cur.directoryProperties.description;
      var sync;
      if (mabFile!='history.mab' && mabFile!='abook.mab' && dirType==2) {
          // ignore history and pab and ldap-addressbooks
        var syncElem = document.getElementById('addressbookssync_'+description);

        if (syncElem.getAttribute('checked'))
          pref.setBoolPref( cur.directoryProperties.prefName+".extensions.addressbookssync", true );
        else
          pref.setBoolPref( cur.directoryProperties.prefName+".extensions.addressbookssync", false );
      }
      try { aBook = cn.getNext(); } catch(e) { break; } // catch
    }

} // finish



function ChooseFile()
{
  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

var x;
try { x=strings.getString("choosefile"); } catch(e) { x='not found';}
  filePicker.init(window, x, nsIFilePicker.modeOpen);
  filePicker.appendFilter( strings.getString("mab") + " (*.mab)", "*.mab;" );

  if( filePicker.show() == nsIFilePicker.returnOK )
  {
    document.getElementById( "MabFilePath" ).value = filePicker.file.path;
    var mabFileName = filePicker.file.leafName;
    var mabName = mabFileName.substr( 0, mabFileName.lastIndexOf(".") );
    mabName = mabName.replace( /_/g, " " );
    document.getElementById( "MabName" ).value = mabName;
  }
} // ChooseFile

function ChoosePath()
{
  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

  filePicker.init(window, strings.getString("choosesyncdir"), nsIFilePicker.modeGetFolder);

  if( filePicker.show() == nsIFilePicker.returnOK )
  {
    document.getElementById( "localpath" ).value = filePicker.file.path;
    document.getElementById( "synclocal" ).selected=true;
  }
} // ChoosePath


function SaveMab()
{
    var mabFile = document.getElementById( "MabList" ).selectedItem.value;
    var mabName = document.getElementById( "MabList" ).selectedItem.label;

    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

    var externMabFileName = mabName.replace( /\s|\./g, "_" ) + ".mab";
    filePicker.defaultString = externMabFileName;
    filePicker.init(window, strings.getString("choosefiledest"), nsIFilePicker.modeSave);
    filePicker.appendFilter( strings.getString("mab") + " (*.mab)", "*.mab;" );

    if( filePicker.show() != nsIFilePicker.returnCancel) { //Ok or Replace!
      if (saveMabFile( mabName, mabFile, filePicker.file.parent, filePicker.file.leafName ))
        alert(strings.getString('stored'));
      else
        alert(strings.getString('storefailed'));
    }
} //


function LoadMab()
{
  var filename = document.getElementById( "MabFilePath" ).value;
  if (!filename) return;

  var mabName = document.getElementById( "MabName" ).value;
  if (!mabName) return;

  var cn = directory.childNodes;
  var aBook = cn.getNext();
  var mabFile='';
  while( aBook != null )
  {
    var cur = aBook.QueryInterface(Components.interfaces.nsIAbDirectory);
    if (cur.directoryProperties.description==mabName) {
      mabFile=cur.directoryProperties.fileName;
      break;
    }
    try { aBook = cn.getNext(); } catch(e) { break; }
  }
  var create;
  if (mabFile) {
    if (mabFile=='history.mab' || mabFile=='abook.mab') {
      alert(strings.getString('nooverwrite'));
      return;
    }
///Umlaute in alerts!!!
    if (!confirm(strings.getString('askoverwrite'))) return;
    create=false;
  } else {
    //create mabFile name
    mabFile = mabName.replace( /\s|\./g, "_" );
    mabFile += '.mab';
    create=true;
  }
  if (loadMabFile(create, mabName, mabFile, null, filename)) {
    document.getElementById( "MabFilePath" ).value='';
    document.getElementById( "MabName" ).value='';
    alert(strings.getString('loaded'));
  } else {
    alert(strings.getString('loadfailed'));
  }
}

function get_password(host, user){
    var dhost= new Object();
    var duser= new Object();
    var pass= new Object();
    try{
      var pmInternal = Components.classes["@mozilla.org/passwordmanager;1"]
                      .createInstance(Components.interfaces.nsIPasswordManagerInternal);
      pmInternal.findPasswordEntry(host,user,"",dhost,duser,pass);
      return pass.value;
    }catch(e){}
    return "";
}

function set_password(host, user, pwd){
    var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"]
            .createInstance(Components.interfaces.nsIPasswordManager);
    try{
      passwordManager.removeUser(host,user);
    }catch(e){}
    passwordManager.addUser(host,user,pwd);
}

function uploadNow()
{
  finish(); //ggf genderte Parameter bernehmen!
  if (pref.getCharPref( "extensions.addressbookssync.synctype")!='none')
    window.open("chrome://addressbookssync/content/upload.xul","_blank","chrome,resizable,titlebar=no");
}

function downloadNow()
{
  finish(); //ggf genderte Parameter bernehmen!
  if (pref.getCharPref( "extensions.addressbookssync.synctype")!='none')
    window.open("chrome://addressbookssync/content/download.xul","_blank","chrome,resizable,titlebar=no");
}
